//// Places a reveal-all mask on all selected layers. May get confused with certain folder structures.
//// Released by Chance Miller without license or guarantee. http://www.middleendian.com/

// Function to that calls weird Photoshop nonsense function to add a reveal-all mask to active layer
function addMask() {
	var idMk = charIDToTypeID("Mk  ");
	var desc2 = new ActionDescriptor();
	var idNw = charIDToTypeID("Nw  ");
	var idChnl = charIDToTypeID("Chnl");
	desc2.putClass(idNw, idChnl);
	var idAt = charIDToTypeID("At  ");
	var ref1 = new ActionReference();
	var idChnl = charIDToTypeID("Chnl");
	var idChnl = charIDToTypeID("Chnl");
	var idMsk = charIDToTypeID("Msk ");
	ref1.putEnumerated(idChnl, idChnl, idMsk);
	desc2.putReference(idAt, ref1);
	var idUsng = charIDToTypeID("Usng");
	var idUsrM = charIDToTypeID("UsrM");
	var idHdAl = charIDToTypeID("RvlA");
	desc2.putEnumerated(idUsng, idUsrM, idHdAl);
	executeAction(idMk, desc2, DialogModes.NO);
}

function main() {
	// Weird Photoshop nonsense to detect selected layers and store them in selected_layers array
	selected_layers=[];
	try {
		var idGrp = stringIDToTypeID( "groupLayersEvent" );
		var descGrp = new ActionDescriptor();
		var refGrp = new ActionReference();
		refGrp.putEnumerated(charIDToTypeID( "Lyr " ),charIDToTypeID( "Ordn" ),charIDToTypeID( "Trgt" ));
		descGrp.putReference(charIDToTypeID( "null" ), refGrp );
		executeAction( idGrp, descGrp, DialogModes.NO );
		for (var ix=0;ix<app.activeDocument.activeLayer.layers.length;ix++) {
			selected_layers.push(app.activeDocument.activeLayer.layers[ix]);
		}
		var id8 = charIDToTypeID( "slct" );
		var desc5 = new ActionDescriptor();
		var id9 = charIDToTypeID( "null" );
		var ref2 = new ActionReference();
		var id10 = charIDToTypeID( "HstS" );
		var id11 = charIDToTypeID( "Ordn" );
		var id12 = charIDToTypeID( "Prvs" );
		ref2.putEnumerated( id10, id11, id12 );
		desc5.putReference( id9, ref2 );
		executeAction( id8, desc5, DialogModes.NO );
	} catch (e) {} // sometimes there are not particularly relevant errors


	// Iterate through selected layers and add label
	if (app.documents.length>0) {
		var docRef = activeDocument;
		for (var i=0; i<selected_layers.length; i++) {
			docRef.activeLayer = selected_layers[i];
			if(!docRef.activeLayer.isBackgroundLayer){
				try{
					addMask();
				} catch (e) {} // sometimes there are not particularly relevant errors
			}
		}
	} else {
		alert('There are no open files');
	};
}
main();